#include <bits/stdc++.h>
using namespace std;

int n,sp;
bool bin[500005][63];
long long in,minop=1000000000000000000;
vector<long long> v;

int main()
{
    ios::sync_with_stdio(false);
    cin>>n;
    for(int i=0;i<n;i++)
    {
        cin>>in;
        v.push_back(in);
        for(long long j=1,k=0;j<=(1ll<<60);j<<=1,k++)
        {
            bin[i][k]=((in&j)>0);
        }
    }
    long long pw=1;
    for(int i=0;i<=60;i++,pw<<=1)
    {
        long long op=0;
        for(int j=0;j<n;j++)
        {
            if(!bin[j][i])
            {
                op+=pw-v[j]%pw;
            }
            if(op>minop)
            {
                break;
            }
        }
        if(op<minop)
        {
            minop=op;
            sp=i;
        }
    }
    for(int i=0;i<n;i++)
    {
        if(!bin[i][sp])
        {
            v[i]+=pw-v[i]%pw;
        }
    }
    for(int i=0;i<=60;i++)
    {
        int cnt=0;
        for(int j=0;j<n;j++)
        {
            cnt+=bin[j][i];
        }
        if(cnt%2==1)
        {
            cout<<minop;
            return 0;
        }
    }
    if(sp==0)
    {
        cout<<minop+2;
    }
    else
    {
        cout<<minop+1;
    }
}